TYPO3.Flow - Task # 33142

Status: Resolved Priority: Should have
Author: Christian Mdiller Category: Reflection

Created: 2012-01-12 Assigned To: Karsten Dambekalns
Updated: 2012-02-14 Due date:

Sprint:

PHP Version:

Has patch: No

Complexity:

Subject: Ignore Tags / Annotations in external libraries, find some good solution

Description

for now we have the ignore list of tags in Packages/Framework/TYPO3.FLOW3/Classes/Reflection/ReflectionService.php

For external libraries with lots of custom tags this is a problem, of course we can patch master specifically all the time, but maybe we
should think about another solution. So a possible way would be to have a core ignore set and allow additions by configuration or just
a globally configurable ignore list. Maybe there are other ideas?

Associated revisions

Revision cebbf8e2 - 2012-02-13 15:10 - Christian Miiller

[FEATURE] Make tag ignores configurable

Makes the list of ignored tags configurable. This can be used to add
tags to the list if needed by your package by simply setting
TYPOS3.FLOWS.reflection.ignoredTags to an array of tag names in your
Settings.yaml.

Change-Id: 12e92e506504c049fd139ec0a8f6a19524a0c38f1

Resolves: #33142
Releases: 1.1

History

#1 - 2012-01-12 13:23 - Adrian Féder
Well for now, we have afaik two possibilities how external libraries could get involved:

1. if it's just a tiny helper library, it's intended to be stored in {PackageRoot}/Resources/PHP/{libraryName} and just included via require. is this
suspected by the problem however?

2. if the FLOW3 package mainly represents the foreing library at all, like it's the case in Imagine or Swift package, the library code is put below
{PackageRoot}/Classes directly.

If this is considered common guideline, | suggest we should only allow customized annotation allowance for files below those two kind of directories.

So basically | agree with Christian making the "ignore" list of annotations just configurable via YAML configuration.
Additional idea could be to allow "mapping" of annotations; i.e. @date
(which is not an official PhpDoc annotation) could get mapped to

@My\SooperdooperToolAnnotations\Date

or such.
#2 - 2012-01-13 11:44 - Peter Beernink

Adrian Foder wrote:

If this is considered common guideline, | suggest we should only allow customized annotation allowance for files below those two kind of

directories.
So basically | agree with Christian making the "ignore" list of annotations just configurable via YAML configuration.
Additional idea could be to allow "mapping" of annotations; i.e.

@date

(which is not an official PhpDoc annotation) could get mapped to
@My\SooperdooperTool\Annotations\Date

or such.

This also make it possible to 'ignore' other tags, when an empty Annotation\lgnore is added.

#3 - 2012-01-19 17:48 - Karsten Dambekalns

- Project changed from TYPO3 Flow Base Distribution to TYPOGS.Flow
- Status changed from New to Accepted

- Assigned To changed from Christian Miiller to Karsten Dambekalns

#4 - 2012-01-19 17:48 - Karsten Dambekalns
- Category set to Reflection

- Target version setto 1.1

- Has patch set to No

#5 - 2012-01-19 17:49 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 3 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/7747

#6 - 2012-01-19 17:49 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.orq/7747

#7 - 2012-01-19 21:02 - Peter Beernink

Karsten | haven't tested your code yet, but it looks like a good solution.

However, when | read the code it looks like one has to copy the default list to the Configuration/Settings.yaml in order to add additional tags.
Is this the intended behaviour?

| can imagine that you have multiple (3rd party) packages which all have one or two tags to exclude. You have to manually check each package on
which tags should be excluded and compile a complete list in your base Settings.yaml.
Or am | completely wrong here and is the array merged with arrays defined in other packages?

#8 - 2012-01-20 10:31 - Bastian Waidelich

Peter Beernink wrote:

However, when | read the code it looks like one has to copy the default list

to the Configuration/Settings.yaml in order to add additional tags.

Good catch, this wouldn't be easily extensible by 3rd party unless we'd change the syntax to something like

ignoredTags:

api:y
package: y

if I'm correct..

Not very beautiful IMO.

What about adding an Annotationinterface (that all annotations need to implement) and an (extensible) whitelist that gets all annontations added

dynamically?

#9 - 2012-01-20 11:58 - Karsten Dambekalns

Check the configuration in the TYPO3.TcPdf package, it simply adds stuff. Worked for me, so unless | missed something, no need to replicate (which

would be stupid).

#10 - 2012-02-13 15:12 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/7747

#11 - 2012-02-14 02:43 - Christian Miiller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:cebbf8e2851b28ffaf32abafbb675e47af6ae783.
